<html>

	<head>
		<script src="https://alqemia.com/public/utilsaotracode.build.js"></script>
	</head>
	
	<body>

			<div id="display">
			</div>
			<input type="text" id="keyboard">
			</input>

			<!--
			OLD :
			
			<div id="bootProgram" style="display:none;">
				B2M|HARD|11|0;
				B2M|HARD|12|1;
				B2M|HARD|13|2;
				B2M|HARD|14|3;
				B2M|HARD|15|4;
				B2M|HARD|16|5;
				B2M|HARD|17|6;
				B2M|HARD|18|7;
				B2M|HARD|19|8;
				GO2|0;
				# START OF NON-BOOT PROGRAMS;
				DAT|Hello world|STR;
				M2B|0|DISP|0;
				DAT|void|STR;
				DAT|void|STR;
				DAT|void|STR;
				DAT|void|STR;
				DAT|void|STR;
				DAT|void|STR;
				END;
			</div>
			
			
			/*
				INSTRUCTIONS:
				
				CMP|memAddress1|memAddress2;
				ADD|memAddress1|memAddress2|memAddress3;
				GO2|instrLine;
				M2B|memAddress|busName|busAddr;
				B2M|busName|busAddr|memAddress;
				DAT|value|type;
				END;

			*/
			-->
			<!-- In hard drive : -->
			<div id="bootProgram" style="display:none;">
				B2M|HARD|17|0;
				B2M|HARD|18|1;
				B2M|HARD|19|2;
				B2M|HARD|20|3;
				B2M|HARD|21|4;
				B2M|HARD|22|5;
				B2M|HARD|23|6;
				B2M|HARD|24|7;
				B2M|HARD|25|8;
				B2M|HARD|26|9;
				B2M|HARD|27|10;
				B2M|HARD|28|11;
				B2M|HARD|29|12;
				B2M|HARD|30|13;
				B2M|HARD|31|14;
				GO2|0;
				# START OF NON-BOOT PROGRAMS;
				DAT|0|INT;
				DAT|10|INT;
				DAT|1|INT;
				ADD|0|2|0;
				M2B|0|DISP|0;
				CMP|0|1;
				GO2|9;
				GO2|3;
				GO2|3;
				M2B|0|DISP|0;
				END;
			</div>
			
						<script>

				//function writeValueFromMemToReg(memAddress,numberRegister);
				//function compareValueReg1AndReg2(numberRegister1,numberRegister2);
				
				//function writeValueFromMemToReg(memAddress);
				//function writeValueFromRegToMem(memAddress);
				
				// goes to instruction line +1 if equals, line +2 if reg is less, line +3 if reg is more, than value at mem address
				//function compareValueRegAndMemGoto(memAddress);


				// BASE FUNCTIONS INTERFACE:
				// Program method :
				// function writeInProgramZoneFromBus(busName,busAddr,instrLine){}
				
				// Flow control method :
				// goes to instruction line +1 if equals, line +2 if value at mem address 1 is less, line +3 if reg is more, than value at mem address 2
				function add(memAddress1,memAddress2,memAddress3){}
				function compareValueMemGoto(memAddress1,memAddress2){}
				function goTo(instrLine){}
				
				// I/O methods :
				function fromMemToBus(memAddress,busName,busAddr){}
				function fromBusToMem(busName,busAddr,memAddress){}
				
				// memory structure :
				// // - program instructions (read-only) ; from beginning
				// // - memory (read-write)				 ; from end
				// peripherics :
				// // - mass (read-write), accessed by bus
				// mass storage structure :
				// // - boot program on first lines
				
				// ------------------------------------------------
				
				// The computer implementation :
				var HARD_DRIVE_BOOT_SECTOR_LINES_NUMBER=16;
				var MEMORY_LINES_MAX_NUMBER=100;
				var memory=new Array(MEMORY_LINES_MAX_NUMBER);
				// (line numbers starts from 0)
				var INSTRUCTIONS_ZONE_START_LINE_NUMBER=0;
				var INSTRUCTIONS_ZONE_END_LINE_NUMBER=Math.floor(MEMORY_LINES_MAX_NUMBER/2)-1;
				var RAM_ZONE_START_LINE_NUMBER=INSTRUCTIONS_ZONE_START_LINE_NUMBER+1;
				var RAM_ZONE_END_LINE_NUMBER=MEMORY_LINES_MAX_NUMBER-1;
				var SEP_INSTR="|";
				var SEP_PROGRAM_INSTRUCTIONS=";";
				var CHAR_COMMENT="#"
				var CLOCK_RATE_MILLIS=100;
				var currentInstructionLine=0;
				
				var BUSES_MAX_ADDRESSES=new Object();

				var HARDDRIVE_BUS="HARD"; // Hard drive
				BUSES_MAX_ADDRESSES[HARDDRIVE_BUS]=100;
				var buses=new Object();
				buses[HARDDRIVE_BUS]=new Array(BUSES_MAX_ADDRESSES[HARDDRIVE_BUS]);

				var DISPLAY_BUS="DISP"; // Screen console
				BUSES_MAX_ADDRESSES[DISPLAY_BUS]=100;
				buses[DISPLAY_BUS]=new Array(BUSES_MAX_ADDRESSES[DISPLAY_BUS]);
				buses[DISPLAY_BUS][0]="";
				
				var KEYBOARD_BUS="KEYB"; // Input console
				BUSES_MAX_ADDRESSES[KEYBOARD_BUS]=10;
				buses[KEYBOARD_BUS]=new Array(BUSES_MAX_ADDRESSES[KEYBOARD_BUS]);
				buses[KEYBOARD_BUS][0]="";
				
				// Methods implementations :

				
				function getValueAndType(instructionStrParam){
					var instructionStr=instructionStrParam;
					if(!instructionStr){
						return null;
					}
					instructionStr=instructionStrParam.trim();
					
					// Ignore comments :
					if(!instructionStr || empty(instructionStr) || instructionStr.charAt(0)===CHAR_COMMENT){
						return null;
					}
					
					var split=instructionStr.split(SEP_INSTR);
					if(empty(split))	return null;
					
					// Stop on end of program :
					if(instructionStr==="END")	return null;
					
					if(split[0]==="DAT"){
						return {value:split[1],type:split[2]};
					}

					return null;
				}
			
				add=function(memAddress1,memAddress2,memAddress3){
					var vt1=getValueAndType(memory[memAddress1]);
					var vt2=getValueAndType(memory[memAddress2]);
					var vt3=getValueAndType(memory[memAddress3]);
					
					//DD
					log(vt1);
					log(vt2);
					log(vt3);
					
					
					if(!vt1 || !vt2)	return;
					if(vt1.type!==vt2.type)	return;
					if(vt1.type==="INT")
						memory[memAddress3]="DAT"+SEP_INSTR+(parseInt(vt1.value)+parseInt(vt2.value))+SEP_INSTR+"INT";
					else if(vt1.type==="STR")
						memory[memAddress3]="DAT"+SEP_INSTR+(vt1.value+vt2.value)+SEP_INSTR+"STR";
					currentInstructionLine+=1;

				}
			
				compareValueMemGoto=function(memAddress1,memAddress2){
				
					var vt1=getValueAndType(memory[memAddress1]);
					var vt2=getValueAndType(memory[memAddress2]);

					
					// Equals
					if(!vt1 && !vt2){
						currentInstructionLine+=1;
						return;
					}
					// vt1 < vt2
					if(!vt1 && vt2){
						currentInstructionLine+=2;
						return;
					}
					// vt1 > vt2
					if(vt1 && !vt2){
						currentInstructionLine+=3;
						return;
					}
					
					// Equals
					if(vt1.value===vt2.value && vt1.type===vt2.type){
						currentInstructionLine+=1;
						return;
					}
					// vt1 < vt2
					if(vt1.value < vt2.value && vt1.type===vt2.type){
						currentInstructionLine+=2;
						return;
					}
					// vt1 > vt2
					if(vt1.value > vt2.value && vt1.type===vt2.type){
						currentInstructionLine+=3;
						return;
					}
					
				};
				
				goTo=function(instrLine){
					currentInstructionLine=instrLine;
				};
				fromMemToBus=function(memAddress,busName,busAddr){
					if(memAddress<INSTRUCTIONS_ZONE_START_LINE_NUMBER || RAM_ZONE_END_LINE_NUMBER<memAddress)	return;
					////DD
					//log("memory["+memAddress+"]:"+memory[memAddress]);
					if(!memory[memAddress]){
						buses[busName][busAddr]=null;
						currentInstructionLine+=1;
						return;
					}
					buses[busName][busAddr]=memory[memAddress].trim();
					currentInstructionLine+=1;
				};
				fromBusToMem=function(busName,busAddr,memAddress){
					if(memAddress<INSTRUCTIONS_ZONE_START_LINE_NUMBER || RAM_ZONE_END_LINE_NUMBER<memAddress)	return;
					////DD
					//log("buses["+busName+"]["+busAddr+"]:"+buses[busName][busAddr]);
					if(!buses[busName][busAddr]){
						memory[memAddress]=null;
						currentInstructionLine+=1;
						return;
					}
					memory[memAddress]=buses[busName][busAddr].trim();
					currentInstructionLine+=1;
				};
				
				function executeInstruction(instructionStrParam){
					if(currentInstructionLine<INSTRUCTIONS_ZONE_START_LINE_NUMBER || INSTRUCTIONS_ZONE_END_LINE_NUMBER<currentInstructionLine) return false;
					var instructionStr=instructionStrParam;
					if(!instructionStr){
						currentInstructionLine+=1;
						return true;
					}
					instructionStr=instructionStrParam.trim();

					//DD
					log(">Execution (line ="+currentInstructionLine+") of : "+instructionStr);

					
					// Ignore comments and empty lines :
					if(!instructionStr || empty(instructionStr) || instructionStr.charAt(0)===CHAR_COMMENT){
						currentInstructionLine+=1;
						return true;
					}

					// Stop on end of program :
					if(instructionStr==="END")	return false;

					
					var split=instructionStr.split(SEP_INSTR);
					if(empty(split))	return false;
					
					
					if(split[0]==="CMP"){
						var memAddress1=parseInt(split[1]);
						var memAddress2=parseInt(split[2]);
						compareValueMemGoto(memAddress1,memAddress2);
					}else if(split[0]==="GO2"){
						var instrLine=parseInt(split[1]);
						goTo(instrLine);
					}else if(split[0]==="M2B"){
						var memAddress=parseInt(split[1]);
						var busName=split[2];
						var busAddr=parseInt(split[3]);
						fromMemToBus(memAddress,busName,busAddr);
					}else if(split[0]==="B2M"){
						var busName=split[1];
						var busAddr=parseInt(split[2]);
						var memAddress=parseInt(split[3]);
						fromBusToMem(busName,busAddr,memAddress);
					}else if(split[0]==="ADD"){
						var memAddress1=parseInt(split[1]);
						var memAddress2=parseInt(split[2]);
						var memAddress3=parseInt(split[3]);
						add(memAddress1,memAddress2,memAddress3);
					}else if(split[0]==="DAT"){
						// Ignore data lines :
						currentInstructionLine+=1;
						return true;
					}
					return true;
				}

				// hard drive :
				buses[HARDDRIVE_BUS]=document.getElementById("bootProgram").innerText.split(SEP_PROGRAM_INSTRUCTIONS);

				// boot :
				// (boot is just putting the 10 first instructions of hard drive in execution memory) :
				for(var i=0;i<HARD_DRIVE_BOOT_SECTOR_LINES_NUMBER;i++)
					memory[i]=buses[HARDDRIVE_BUS][i];
				
				// TRACE
				log("Start of program...");
				
				var pe=setInterval(function () {
				
					buses[KEYBOARD_BUS][0]=document.getElementById("keyboard").value;
					document.getElementById("display").innerHTML=buses[DISPLAY_BUS][0];

					var executionResult=executeInstruction(memory[currentInstructionLine]);
					
					if(!executionResult){
					
						// TRACE
						log("We stop execution");
						
						//TRACE
						log(memory);
				
						clearInterval(pe);;
						return;
					}

					
				}, CLOCK_RATE_MILLIS);
		
			
				
				log("End of program.");	
				
				
				
		</script>
		
	
	</body>

</html>